## Acknowledge financial transaction

### cURL

```
curl --request POST \
  --url https://api.fabric.inc/v3/invoices/{invoiceId}/acknowledge \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'x-fabric-channel-id: <x-fabric-channel-id>' \
  --header 'x-fabric-tenant-id: <x-fabric-tenant-id>' \
  --data '
{
  "acknowledgedAt": "2022-08-01T20:03:28.483Z",
  "attributes": {
    "fraudCheckStatus": "UPDATED",
    "fraudStatus": "FRAUD_PASS"
  }
}
'```

### Python

```
import requests

url = "https://api.fabric.inc/v3/invoices/{invoiceId}/acknowledge"

payload = {
    "acknowledgedAt": "2022-08-01T20:03:28.483Z",
    "attributes": {
        "fraudCheckStatus": "UPDATED",
        "fraudStatus": "FRAUD_PASS"
    }
}
headers = {
    "x-fabric-tenant-id": "<x-fabric-tenant-id>",
    "x-fabric-channel-id": "<x-fabric-channel-id>",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

### JavaScript (Fetch)

```
const options = {
  method: 'POST',
  headers: {
    'x-fabric-tenant-id': '<x-fabric-tenant-id>',
    'x-fabric-channel-id': '<x-fabric-channel-id>',
    Authorization: 'Bearer <token>',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({
    acknowledgedAt: '2022-08-01T20:03:28.483Z',
    attributes: {fraudCheckStatus: 'UPDATED', fraudStatus: 'FRAUD_PASS'}
  })
};

fetch('https://api.fabric.inc/v3/invoices/{invoiceId}/acknowledge', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
```

### PHP

```
<?php

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.fabric.inc/v3/invoices/{invoiceId}/acknowledge",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'acknowledgedAt' => '2022-08-01T20:03:28.483Z',
    'attributes' => [
        'fraudCheckStatus' => 'UPDATED',
        'fraudStatus' => 'FRAUD_PASS'
    ]
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json",
    "x-fabric-channel-id: <x-fabric-channel-id>",
    "x-fabric-tenant-id: <x-fabric-tenant-id>"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
?>
```

### Go

```
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

url := "https://api.fabric.inc/v3/invoices/{invoiceId}/acknowledge"

payload := strings.NewReader("{\n  \"acknowledgedAt\": \"2022-08-01T20:03:28.483Z\",\n  \"attributes\": {\n    \"fraudCheckStatus\": \"UPDATED\",\n    \"fraudStatus\": \"FRAUD_PASS\"\n  }\n}")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("x-fabric-tenant-id", "<x-fabric-tenant-id>")
	req.Header.Add("x-fabric-channel-id", "<x-fabric-channel-id>")
	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}
```

### Error Responses

#### 200 OK
```
{
  "message": "Success"
}
```

#### 400 Bad Request
```
{
  "errors": [
    {
      "message": "Invalid request",
      "type": "CLIENT_ERROR"
    }
  ],
  "message": "Bad request",
  "type": "CLIENT_ERROR"
}
```

#### 401 Unauthorized
```
{
  "message": "Unauthorized request",
  "type": "CLIENT_ERROR"
}
```

#### 404 Not Found
```
{
  "message": "Not found",
  "type": "CLIENT_ERROR"
}
```

#### 500 Internal Server Error
```
{
  "message": "Internal server error",
  "type": "SERVER_ERROR"
}
```

### Authorization

* Authorization: Bearer <token>

### Headers

- `x-fabric-tenant-id`: string (required)
- `x-fabric-channel-id`: string (required)

### Path Parameters

- `invoiceId`: string (required)

### Body

- `acknowledgedAt`: string<date-time> (required)
- `attributes`: object  (Merchant-defined custom attributes)

### Response

- `message`: string  (Generic response)

#### Example
- Request Example for acknowledging financial transaction:
```json
{
  "acknowledgedAt": "2022-08-01T20:03:28.483Z",
  "attributes": {
    "fraudCheckStatus": "UPDATED",
    "fraudStatus": "FRAUD_PASS"
  }
}
```
